﻿// // ******************************************************************
// //       /\ /|       @File         ProtocolRS232Enums.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-5-7
// //      /  \\        @Modified      2024-5-13
// //    *(__\_\
// // ******************************************************************

#pragma once
#include "../EdgePulse.h"
#include "../BaseEnums/DataCheckEnums.h"

namespace Protocol::ProtocolRS232
{
    class Enums
    {
    public:
        enum class RS232DecodeEventType: int32_t
        {
            None,
            Start,
            Data,
            Parity,
        };

        enum class DataBitWidth: int32_t
        {
            DataBitWidth_5Bit = 5,
            DataBitWidth_6Bit,
            DataBitWidth_7Bit,
            DataBitWidth_8Bit
        };


        enum class StopBit: int32_t
        {
            StopBit_1bit,
            StopBit_2bit
        };

        enum class BPSList: int32_t
        {
            BPSList_2400,
            BPSList_4800,
            BPSList_9600,
            BPSList_19200,
            BPSList_38400,
            BPSList_57600,
            BPSList_115200,
            BPSList_Custom
        };
    };
}
