﻿// // ******************************************************************
// //       /\ /|       @File         UsbDecode.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-3-14
// //      /  \\        @Modified      2024-5-13
// //    *(__\_\
// // ******************************************************************

#pragma once
// #include <iostream>
#include <future>
// #include <chrono>
// #include <thread>
// #include <cmath>

// #include "../CommonHelper.h"
// #include "../EnumTypeInfo.h"
#include "../EdgePulse.h"

#include "SYNC.h"
#include "ProtocolUSBEnums.h"
#include "UsbParams.h"
#include "UsbDecodeResult.h"
#include "UsbPacket.h"

#include "../ProtocolDecodeBase.h"

namespace Protocol::ProtocolUsb
{
    class UsbDecode : public ProtocolDecodeBase
    {
    private:
        static bool ParseData(const UsbDecodeParams& options,
                              const TwoLevelEdgePulse& edgePluses1,
                              const TwoLevelEdgePulse& edgePluses2,
                              UsbDecodeResult& decodeResult);

        bool ParseData(UsbDecodeParams options, std::vector<TwoLevelEdgePulse> edgePluses1,
                       std::vector<TwoLevelEdgePulse> edgePluses2) const;

        static bool CheckDifferenceWithinThreshold(const double* array, int32_t size, double threshold = 0.15);

        static void ClearEdgeArray(Edge* edges, int32_t size);

        static bool CheckSyncEdges(Edge startEdge, const Edge* edges);

        static bool CheckSyncSpans(const TwoLevelEdgePulse* node, int32_t& leftOverSize, int32_t count,
                                   int32_t& avgSpans);

        static bool CheckSyncSpansByArray(const int32_t* startIndex, int32_t count, int32_t& avgSpans);

        bool FindAllSyncs(TwoLevelEdgePulse* node, int32_t& leftOverSize,
                          std::vector<SYNC>& allSYNC, bool polarity = false) const;

        bool FindPackets(UsbDecodeParams options, TwoLevelEdgePulse* node, int32_t& leftOverSize,
                         std::vector<UsbPacket>& allPacket,
                         bool polarity = false) const;

    protected:
        //todo del and change
        void Decode(const DecodeParams& decodeParams);
        //void Decode(const DecodeParams& decodeParams) override;
        void QuantizeDecode(const QuantizeParams& decodeParams) override;

    public:
        DecodeResult* GetResult() override;
        ~UsbDecode() override;
    };
}
