﻿// // ******************************************************************
// //       /\ /|       @File         QuantizeParams.cpp
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-5-6
// //      /  \\        @Modified      2024-5-13
// //    *(__\_\
// // ******************************************************************

#include "QuantizeParams.h"

namespace Protocol
{
    QuantizeParams::QuantizeParams(): LevelOption(), BitDepth(0), SamplingRate(0), OversamplingRatio(0),
                                      SignalAmplitude(0),
                                      SignalFrequency(0),
                                      SignalToNoiseRatio(0),
                                      ErrorDetectionAndCorrection(false)
    {
        // 初始化默认参数...
    }

    QuantizeParams::QuantizeParams(const QuantizeParams& quantizeParams): LevelOption(quantizeParams.LevelOption),
                                                                          BitDepth(quantizeParams.BitDepth),
                                                                          SamplingRate(quantizeParams.SamplingRate),
                                                                          OversamplingRatio(
                                                                              quantizeParams.OversamplingRatio),
                                                                          SignalAmplitude(quantizeParams.SamplingRate),
                                                                          SignalFrequency(
                                                                              quantizeParams.SignalFrequency),
                                                                          SignalToNoiseRatio(
                                                                              quantizeParams.SignalToNoiseRatio),
                                                                          ErrorDetectionAndCorrection(
                                                                              quantizeParams.
                                                                              ErrorDetectionAndCorrection)
    {
    }

    QuantizeParams::~QuantizeParams() = default;
}
